unit uMainTester;
{
PROJECT: DIALTester.exe
PURPOSE: Reference implementation for WCAP.DLL 5.0
DATE: November-2002
COMPILER: Borland Delphi 5/6
AUTHOR: J.Cobb jay_cobb@worldpac.com

LEGALESE: This code is copyrighted 2002 by WorldPac and its use is limited for
the purpose of demonstrating the features and capabilities WCAP.DLL. No warranty
blah, blah...
}
interface
//{$D-}
//{$L-}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, ExtCtrls, ComCtrls, Menus, XmlParser, XmlObjModel;

type
  TForm1 = class(TForm)
    stsStatus: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    memData: TMemo;
    sockClient: TClientSocket;
    TabSheet2: TTabSheet;
    xmlObject: TXmlObjModel;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    btnDLLConnect: TButton;
    btnDLLSetClient: TButton;
    btnStartServer: TButton;
    btnConnectAS: TButton;
    Panel2: TPanel;
    Memo1: TMemo;
    btnDLLDisco: TButton;
    GroupBox2: TGroupBox;
    btnDLLShowCatalog: TButton;
    btnDLLShowPnA: TButton;
    btnDLLCreateOrder: TButton;
    btnDLLGetProdQuote: TButton;
    btnDLLGetMany: TButton;
    GroupBox3: TGroupBox;
    cbDebug: TComboBox;
    cbAutoStart: TComboBox;
    btnDLLClear: TButton;
    btnDLLClipboard: TButton;
    btnDLLLine: TButton;
    lblDLLStatus: TLabel;
    btnRegReceiveAS: TButton;
    lblSetFocus: TLabel;
    Panel4: TPanel;
    GroupBox4: TGroupBox;
    btnConnect: TButton;
    btnDisConnect: TButton;
    btnSetCliProp: TButton;
    GroupBox5: TGroupBox;
    btnShowPnA: TButton;
    btnShowCatalog: TButton;
    btnCreateOrder: TButton;
    btnGetProdQuote: TButton;
    btnGetMany: TButton;
    GroupBox6: TGroupBox;
    btnClip: TButton;
    btnAddLine: TButton;
    btnClear: TButton;
    timer: TTimer;
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisConnectClick(Sender: TObject);
    procedure sockClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure sockClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure sockClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure btnClipClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnAddLineClick(Sender: TObject);
    procedure btnDLLConnectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDLLSetClientClick(Sender: TObject);
    procedure btnDLLDiscoClick(Sender: TObject);
    procedure btnDLLClearClick(Sender: TObject);
    procedure btnDLLLineClick(Sender: TObject);
    procedure btnDLLClipboardClick(Sender: TObject);
    procedure lblSetFocusClick(Sender: TObject);
    procedure btnStartServerClick(Sender: TObject);
    procedure btnRegReceiveASClick(Sender: TObject);
    procedure btnConnectASClick(Sender: TObject);
    procedure btnClickHandler(Sender: TObject);
    procedure cbDebugChange(Sender: TObject);
    procedure btnDLLManyClick(Sender: TObject);
    procedure timerTimer(Sender: TObject);

  private
    FSocket :TCustomWinSocket;
    FCount :Integer;
    FServerHandle :LongInt;
    procedure FastMessagesDLL;
    procedure FastMessagesDirect;

  end;

  procedure CalledBack(PC :PChar);

var
  Form1: TForm1;

implementation

function WCAPConnect(Host :PChar; Post :Integer) :LongBool;
  stdcall;
  external 'wcap.dll';

function WCAPConnectAS(Host :PChar; Port, Autostart :Integer) :LongBool;
  stdcall;
  external 'wcap.dll';

function WCAPConnected :LongBool;
  stdcall;
  external 'wcap.dll';

procedure WCAPDisconnect;
  stdcall;
  external 'wcap.dll';

procedure WCAPSend(XMLDoc :PChar);
  stdcall;
  external 'wcap.dll';

function WCAPStartServer :LongBool;
  stdcall;
  external 'wcap.dll';

procedure WCAPRegisterReceive(AProc :Pointer);
  stdcall;
  external 'wcap.dll';

procedure WCAPDebugEnable(EnableLevel :Integer);
  stdcall;
  external 'wcap.dll';

procedure WCAPDebugWrite(DebugString :PChar);
  stdcall;
  external 'wcap.dll';

{$R *.DFM}

{*******************************************************************************
EVENT: OnCreate: Create form
*******************************************************************************}
procedure TForm1.FormCreate(Sender: TObject);
begin
  memData.text := '';
  FCount := 0;
  WCAPDebugEnable(0);
  cbDebug.ItemIndex := 0;
  cbAutoStart.ItemIndex := 1;

end; {TForm1.FormCreate}

{*******************************************************************************
EVENT: OnClick button connect
*******************************************************************************}
procedure TForm1.btnConnectClick(Sender: TObject);
begin
// Activate the socket
  sockClient.Host := 'localhost';
  sockClient.Port := 17943;
  sockClient.Active := True;

end; {TForm1.btnConnectClick}

{*******************************************************************************
EVENT: OnDisConnect
*******************************************************************************}
procedure TForm1.btnDisConnectClick(Sender: TObject);
begin
  sockClient.Active := False;
  memData.Text := '';

end; {TForm1.btnDisConnectClick}

{*******************************************************************************
EVENT: OnClientRead: Remote connection (client) has data and requires data to be
pulled.
This event should buffer and parse incoming stream in search of the <?xp ?/>
processing option. This is so if the client has *a lot* of data that is not read
in the first pass, this event may be called multiple time to complete the
transaction.
*******************************************************************************}
procedure TForm1.sockClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
  s :String;

begin
  s := Socket.ReceiveText;
  memData.text := memData.text + s;

end; {TForm1.sockClientRead}

{*******************************************************************************
EVENT: OnClick of one of the XML buttons
*******************************************************************************}
procedure TForm1.btnClickHandler(Sender: TObject);
var
  s :TMemoryStream;
  sWork :String;

begin
  memData.Text := '';
  if Sender = btnShowCatalog then
  begin
    s := TMemoryStream.Create;
    s.SetSize(1024);
    s.LoadFromFile('C:\XMLDocs\showCatalog.xml');
    s.Position := 0;
    FSocket.SendStream(s); // free'd by socket... no need to destroy
  end;

  if Sender = btnCreateOrder then
  begin
    s := TMemoryStream.Create;
    s.SetSize(1024);
    s.LoadFromFile('C:\XMLDocs\createOrder.xml');
    s.Position := 0;
    FSocket.SendStream(s); // free'd by socket... no need to destroy
  end;

  if Sender = btnShowPnA then
  begin
    s := TMemoryStream.Create;
    s.SetSize(1024);
    s.LoadFromFile('C:\XMLDocs\ShowPnA.xml');
    s.Position := 0;
    FSocket.SendStream(s); // free'd by socket... no need to destroy
  end;


  if Sender = btnGetProdQuote then
  begin
    s := TMemoryStream.Create;
    s.SetSize(1024);
    s.LoadFromFile('C:\XMLDocs\GetProdQuote.xml');
    s.Position := 0;
    FSocket.SendStream(s); // free'd by socket... no need to destroy
  end;

  if Sender = btnSetCliProp then
  begin
    s := TMemoryStream.Create;
    s.SetSize(1024);
    s.LoadFromFile('C:\XMLDocs\SetClientProps.xml');
    s.Position := 0;
    SetLength(sWork, s.Size);
    s.Read(sWork[1], s.Size);

    sWork := Format(sWork, [IntToStr(Self.Handle)]);
    FSocket.SendText(sWork);
    s.Free;
  end;

{+++++++++++++
++++++++++++++}
// Get many docs
  if Sender = btnGetMany then
  begin
    FastMessagesDirect(); // change to FastMessagesDLL to use test DLL
    exit;

  end;

end; {TForm1.btnClickHandler}

{*******************************************************************************
EVENT: OnClientConnect: Got a good connect, save the socket identifier
*******************************************************************************}
procedure TForm1.sockClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  FSocket := Socket;

end; {TForm1.sockClientConnect}

{*******************************************************************************
EVENT: OnClientDisConnect: Reset the form var socket reference
*******************************************************************************}
procedure TForm1.sockClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  FSocket := nil;

end; {TForm1.sockClientDisconnect}

{*******************************************************************************
EVENT: load clipboard with contents of memo
*******************************************************************************}
procedure TForm1.btnClipClick(Sender: TObject);
begin
  memData.SelectAll;
  memData.CopyToClipboard;

end; {TForm1.btnClipClick}

{*******************************************************************************
EVENT: clear memo
*******************************************************************************}
procedure TForm1.btnClearClick(Sender: TObject);
begin
  memData.Text := ''

end; {TForm1.btnClearClick}

{*******************************************************************************
EVENT: Add new line to memo
*******************************************************************************}
procedure TForm1.btnAddLineClick(Sender: TObject);
begin
  memData.Text := memData.Text + #13#10 + #13#10;

end; {TForm1.btnAddLineClick}



{>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                wcap.dll

<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<}



{*******************************************************************************
EVENT: OnClick start server
*******************************************************************************}
procedure TForm1.btnStartServerClick(Sender: TObject);
begin
  if NOT WCAPStartServer then
    MessageDlg('Oooops! Server not started', mtWarning, [mbOK], 0);

end; {TForm1.btnStartServerClick(}

{*******************************************************************************
EVENT: OnClick register recieve with application handle for Autostart of
speedDIAL
*******************************************************************************}
procedure TForm1.btnRegReceiveASClick(Sender: TObject);
begin
  WCAPRegisterReceive(@CalledBack);

end; {TForm1.btnRegReceiveASClick}

{*******************************************************************************
EVENT: OnClick to connect DLL to DIAL.
*******************************************************************************}
procedure TForm1.btnDLLConnectClick(Sender: TObject);
begin
  WCAPRegisterReceive(@CalledBack);

  if WCAPConnect('localhost', 17943) then
    lblDLLStatus.Caption := 'Looks ok';

end; {TForm1.btnDLLConnectClick}

{*******************************************************************************
EVENT: OnClick to connect DLL to DIAL
*******************************************************************************}
procedure TForm1.btnConnectASClick(Sender: TObject);
begin
  WCAPRegisterReceive(@CalledBack);

  if (WCAPConnectAS('localhost', 17943, cbAutoStart.ItemIndex)) then
    lblDLLStatus.Caption := 'Looks ok';

end; {TForm1.btnDLLConnectClick}

{*******************************************************************************
EVENT Click to disconnect from WCAP
*******************************************************************************}
procedure TForm1.btnDLLDiscoClick(Sender: TObject);
begin
  WCAPDisconnect;
  lblSetFocus.Font.Color := clWindowText;

end; {TForm1.btnDLLDiscoClick}

{*******************************************************************************
EVENT: Clear the memo box
*******************************************************************************}
procedure TForm1.btnDLLClearClick(Sender: TObject);
begin
  Memo1.Text := '';

end; {TForm1.btnDLLClearClick}

{*******************************************************************************
EVENT: Add line to memo
*******************************************************************************}
procedure TForm1.btnDLLLineClick(Sender: TObject);
begin
  Memo1.Text := memData.Text + #13#10 + #13#10;

end; {TForm1.btnDLLLineClick}

{*******************************************************************************
EVENT: Copy contents to clipboard
*******************************************************************************}
procedure TForm1.btnDLLClipboardClick(Sender: TObject);
begin
  Memo1.SelectAll;
  Memo1.CopyToClipboard;

end; {TForm1.btnDLLClipboardClick}

{*******************************************************************************
EVENT: Set focus on remote application
*******************************************************************************}
procedure TForm1.lblSetFocusClick(Sender: TObject);
begin
  if FServerHandle <> 0 then
    SetForegroundWindow(FServerHandle);

end; {TForm1.lblSetFocusClick}

{*******************************************************************************
EVENT: Combo box chooser to set debug level
*******************************************************************************}
procedure TForm1.cbDebugChange(Sender: TObject);
begin
  WCAPDebugEnable(cbDebug.ItemIndex);

end; {TForm1.cbDebugChange}

{*******************************************************************************
EVENT:
*******************************************************************************}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WCAPDisconnect;

end; {TForm1.FormClose}

{*******************************************************************************
EVENT:
*******************************************************************************}
procedure TForm1.btnDLLSetClientClick(Sender: TObject);
var
  pc :PChar;
  ms :TMemoryStream;
  sWork :String;


//--------------------------
begin
  if NOT WCAPConnected then
    exit;

  WCAPDebugWrite(PChar('..setting client properties..'));
  pc := StrAlloc(1024);

  if Sender = btnDLLSetClient then
  begin
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\SetClientProps.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    sWork := Format(sWork, [IntToStr(Self.Handle)]);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
  end;
  if Sender = btnDLLShowCatalog then
  begin
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\showCatalog.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
  end;
  if Sender = btnDLLShowPnA then
  begin
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\ShowPnA.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
  end;
  if Sender = btnDLLCreateOrder then
  begin
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\createOrder.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
  end;
  if Sender = btnDLLGetProdQuote then
  begin
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\GetProdQuote.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
  end;

  if Sender = btnDLLGetMany then
  begin
  // Makes
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\getMakes.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
    StrDispose(pc);

  // Models
    pc := StrAlloc(1024);
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\getModels.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
    StrDispose(pc);

  // brands
    pc := StrAlloc(1024);
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\getBrands.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
    StrDispose(pc);

  // Models
    pc := StrAlloc(1024);
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\getModels.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;
    StrDispose(pc);

  // Show cat
    pc := StrAlloc(1024);
    ms := TMemoryStream.Create;
    ms.SetSize(1024);
    ms.LoadFromFile('C:\XMLDocs\showCatalog.xml');
    ms.Position := 0;
    SetLength(sWork, ms.Size);
    ms.Read(sWork[1], ms.Size);
    StrPCopy(pc, sWork);
    WCAPSend(pc);
    ms.Free;

  end;

  StrDispose(pc);

end;


{*******************************************************************************
PROCEDURE CalledBack routine is a generic handler for data coming in from
DIAL/DLL
*******************************************************************************}
procedure CalledBack(PC: PChar);
var
  sDocType, sText :String;
  iX :Integer;
  XmlList :TXmlNodeList;

begin
  with Form1 do
  begin
    Memo1.Text := Form1.Memo1.Text + String(PC);
    Inc(Form1.FCount);
    lblDLLStatus.Caption := IntToStr(Form1.FCount);
    iX := Pos('Hello', String(PC));
    if (iX > 40) AND (iX < 60) then
    begin
      xmlObject.ClearDocument;
      xmlObject.LoadMemory(PC);
      sDocType := Trim(xmlObject.Document.DocumentElement.TagName);
      if sDocType = 'Hello' then
      begin
        XmlList :=
          xmlObject.Document.DocumentElement.SelectNodes('Win32WindowHandle');

        if XmlList.Length > 0 then //need to tranlate AAIA code
        begin
          sText := TXmlElement(XmlList.Item(0)).ElementText;
          try
            FServerHandle := StrToInt(sText);
            lblSetFocus.Font.Color := clBlue;
          except
            FServerHandle := 0;
          end;
          XmlList.Free;

        end;
      end;

    end;
  end;

end; {CalledBack}

{*******************************************************************************
PROCEDURE btnDLLManyClick
*******************************************************************************}
procedure TForm1.btnDLLManyClick(Sender: TObject);
begin
  FastMessagesDLL;

end; {TForm1.btnDLLManyClick}

{*******************************************************************************
PROCEDURE btnDLLManyClick
*******************************************************************************}
procedure TForm1.FastMessagesDLL();
var
  pc :PChar;
  ms :TMemoryStream;
  sWork :String;

begin
  pc := StrAlloc(1024);

// Multiple request
  {ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\multipleReq.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);
  sWork := Format(sWork, [IntToStr(Self.Handle)]);
  StrPCopy(pc, sWork);
  WCAPSend(pc);
  ms.Free;}

// Set client properties
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\SetClientProps.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);
  sWork := Format(sWork, [IntToStr(Self.Handle)]);
  StrPCopy(pc, sWork);
  WCAPSend(pc);
  ms.Free;

// A timer to slightly separate the send of the second document.
  //timer.Interval := 1;
  //timer.Enabled := true;
  //exit;

// Create an order
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\createOrder.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);
  StrPCopy(pc, sWork);
  WCAPSend(pc);
  ms.Free;

// Show catalog
  {ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\showCatalog.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);
  StrPCopy(pc, sWork);
  WCAPSend(pc);
  ms.Free;}

  StrDispose(pc);

end; {TForm1.FastMessagesDLL}

{*******************************************************************************
PROCEDURE FastMessagesDirect for direct connected WCAP
*******************************************************************************}
procedure TForm1.FastMessagesDirect();
var
  ms :TMemoryStream;
  sWork :String;

begin

// supported docs
  {ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\GetWCAPDocs.xml');
  ms.Position := 0;
  FSocket.SendStream(s); // free'd by socket... no need to destroy
}
// set props
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\SetClientProps.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);

  sWork := Format(sWork, [IntToStr(Self.Handle)]);
  FSocket.SendText(sWork);
  ms.Free;

// A timer to slightly separate the send of the second document.
  //timer.Interval := 1;
  //timer.Enabled := true;
  //exit;

// get models
  {s := TMemoryStream.Create;
  s.SetSize(1024);
  s.LoadFromFile('C:\XMLDocs\getModels.xml');
  s.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy
   }
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\createOrder.xml');
  ms.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy

{
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\getModels.xml');
  ms.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy

// show catalog
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\showCatalog.xml');
  ms.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy

// show pna
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\ShowPnA.xml');
  ms.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy
 }

end; {TForm1.FastMessagesDirect}

{*******************************************************************************
PROCEDURE Event timer. A problem in speedDIAL (DIAL4.x is ok) Crimson XML parser
package refuses to parse 2 (or more?) closely spaced WCAP docs. By introducing a
short delay, the XML parser happily acknowledges the second document.
*******************************************************************************}
procedure TForm1.timerTimer(Sender: TObject);
var
  pc :PChar;
  ms :TMemoryStream;
  sWork :String;

begin
  timer.Enabled := false;
  pc := StrAlloc(1024);

// direct - use this fragment for test home-grown direct connected
  ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\createOrder.xml');
  ms.Position := 0;
  FSocket.SendStream(ms); // free'd by socket... no need to destroy


// dll - use this fragment for testing the dll
  {ms := TMemoryStream.Create;
  ms.SetSize(1024);
  ms.LoadFromFile('C:\XMLDocs\createOrder.xml');
  ms.Position := 0;
  SetLength(sWork, ms.Size);
  ms.Read(sWork[1], ms.Size);
  StrPCopy(pc, sWork);
  WCAPSend(pc);
  ms.Free;

  StrDispose(pc);}

end; {TForm1.timerTimer}

end.
